﻿-- Array of valid zones;
local Inc_validZone = 
{
	"Stables", "Blacksmith", "Lumber Mill", "Gold Mine", "Trollbane Hall", "Defiler's Den", -- Arathi
	"Mage Tower", "Draeni Ruins", "Blood Elf Tower", "Fel Reaver Ruins" -- EOTS
};


-- Registering Events
function INCOMING_RegisterEvent()
    this:RegisterEvent("CHAT_MSG_CHANNEL");
	this:RegisterEvent("CHAT_MSG_ADDON");
    this:RegisterEvent("ZONE_CHANGED");
    this:RegisterEvent("BATTLEFIELDS_CLOSED");
	
-- SendChatMessage("Registered");
    INCOMING_ActivateUI();
   
end

-- Util function To Hide interface
function Hide()
    BasinCryForm:Hide();
end

-- Main Code to check if the IncomingUI should be shown
function INCOMING_ActivateUI()
    
    
    local zoneText = GetMinimapZoneText();
    if(INCOMING_IsValidZone(zoneText) == 1) then
        if(event == "BATTLEFIELDS_CLOSED") then
			BasinCryForm:Hide();
			return;
		end
		BasinCryForm:Show();
	else 
        BasinCryForm:Hide();
    end
end

-- Sends the warning message to everyone in the battleground channel via the /bg channel
function INCOMING_SendIncomingMessage()
    local zoneText = GetMinimapZoneText();
    if(INCOMING_IsValidZone(zoneText) == 1) then
        SendChatMessage("<AddOn:Incoming> ".."Incoming" ..zoneText, "BATTLEGROUND");
		SendWarningRequest();
    end
end

-- Sends the all clear message to everyone in the Battlegroud channel via the /bg channel
function INCOMING_SendAllCleadMessage()
    local zoneText = GetMinimapZoneText();
    if(INCOMING_IsValidZone(zoneText) == 1) then
        SendChatMessage("<AddOn:Incoming> "..zoneText.." is all Clear", "BATTLEGROUND");
    end
end

-- Checks if player is in appropriate Zone, 
-- Return 1 if in Arathi Basin
function INCOMING_IsValidZone(zoneText)
    for i=1,getn (Inc_validZone) do
      if(zoneText == Inc_validZone[i])then
         
        return 1;
      end
    end
     return 0;
end
