-- The Objective of this file is to make addon's communicate with each other and then
-- play a Sound to indicate a warning if someone call's an incoming

-- Send a warning to the raid that a base in going to be underattack
local AddonName = "Incoming";
local WarningType = "BATTLEGROUND";
local WarningValidityTime = 6; -- Time in seconds
local mute = false;


function SendWarningRequest()
	-- Send a warning to the chatChannel
	local addOnMsg = GetMinimapZoneText();
	SendAddonMessage(AddonName, addOnMsg, WarningType);
-- SendChatMessage(addOnMsg);
end

-- the main() function for the Sound Operations
function ReplyToWarningRequest()
-- check if the addon paramaters are correct name, msg,
-- check if the event if correct 
-- check if the player sending is in the raid
		local prefix = arg1; -- pefix
		local addonMsg = arg2; -- msg
		local addonChannel = arg3; -- channel
		local senderName = arg4; --sender name
		
		
		if (event == "CHAT_MSG_ADDON" and addonChannel == WarningType and prefix == AddonName)  then
--SendChatMessage("Reacting To Query");
			local currentWarning = CreateWarning(senderName, addonMsg);
			-- remove any warning's that have their time expired;
			PurgeWarningList();
			--ListWarnings()
			
			if(IsWarningValid(currentWarning) == true) then
			-- if warning is valid
				PlayWarningSound();
				-- playSound
				InsertWarning(currentWarning);
				-- AddWarning to Recent Warnings
			else
			-- else
				-- don't play Sound
			end
		end
		
		
	

end

-- SpamProtection functions
local ListOfRecentWarnings = {};
local SoundSwitch = true;

function CreateWarning(senderName, warningLocation)
	local tempWarning = {PlayerName = "", WarningLocation = "", WarningStartTime = nil};
	tempWarning["PlayerName"] = senderName;
	tempWarning["WarningLocation"] = warningLocation;
	tempWarning["WarningStartTime"] = GetTime();
	
--SendChatMessage("CreatingWarning");
	return tempWarning;
end

function GetZone(msg)
	return zoneText;
end

function IsWarningValid(tempWarning)
	-- check for invalid formats;
-- SendChatMessage("Checking Validity");
	if(INCOMING_IsValidZone(tempWarning["WarningLocation"]) == 0) then
-- SendChatMessage("IllegalZoneName: Invalid Warning "..tempWarning["WarningLocation"]);
		return false;
	end;
	
	-- check if the warning has been repeated
	for i = getn(ListOfRecentWarnings),1, -1 do
		-- checks if a given warning has already been made
		-- if yes then return 0 
		if(ListOfRecentWarnings[i]["PlayerName"] == tempWarning["PlayerName"]) then
-- SendChatMessage("IllegalName: Invalid Warning");
			return false;
		end
		
		if(ListOfRecentWarnings[i]["WarningLocation"] == tempWarning["WarningLocation"])then
-- SendChatMessage("ExistingZone:Invalid Warning");
			return false;
		end
		
	end
	-- else 
		-- return 1
	return true;
	
	
end

function InsertWarning(tempWarning)

	-- put the warning into the ListOfRecentWarnings;
	table.insert(ListOfRecentWarnings, tempWarning);
-- SendChatMessage("Inserting Message");
	
end

-- Debug function
function ListWarnings()
	-- SendChatMessage("Listing");
	for i = getn(ListOfRecentWarnings),1, -1 do
		local playerName = ListOfRecentWarnings[i]["PlayerName"];
-- SendChatMessage(playerName);
		local Location = ListOfRecentWarnings[i]["WarningLocation"];
-- SendChatMessage(Location);
		local StartTime = ListOfRecentWarnings[i]["WarningStartTime"];
-- SendChatMessage(StartTime);
	end	
end

function PurgeWarningList()
-- SendChatMessage("PurgingList");
	for i = getn(ListOfRecentWarnings),1, -1 do
-- SendChatMessage(i);
	
	-- check if the time compnent of the Warning has expired
		local timeElapsed = GetTime() - ListOfRecentWarnings[i]["WarningStartTime"];
-- SendChatMessage(timeElapsed.."    "..WarningValidityTime);
		-- check if more than the allocated time has passed
		if(timeElapsed >  WarningValidityTime) then
			RemoveWarning(i);
		end
	end

end

function RemoveWarning(index)
-- SendChatMessage("Removing");
	table.remove(ListOfRecentWarnings, index);
end

-- Sound functions
function PlayWarningSound()
	if(mute == false) then
-- SendChatMessage("Playing Sound");
		PlaySoundFile("Sound\\Spells\\IllidanShadowBlast1.wav")
	end
	-- Play the default warning Sound
end

function PlayAllClearSound()
	-- Play the default all clear sound
end 


-- Mute Switch just incase the Sound gets annoying
function FlipMuteSwitch()
	if(mute == false) then 
		mute = true;
	else
		mute = true;
	end	
end 